/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.crossover;

import org.opt4j.core.Genotype;
import org.opt4j.core.genotype.CompositeGenotype;
import org.opt4j.operators.crossover.Crossover;
import org.opt4j.operators.crossover.Pair;

/**
 * Crossover operator performing a No-Op. It is employed whenever no crossover operation shall be
 * applied to {@link Genotype}s since Opt4J would use a a generic crossover operator otherwise.
 * Useful for {@link CompositeGenotype}s.
 * 
 * @author diewald
 */
public class NopCrossover implements Crossover<Genotype> {
	/** {@inheritDoc} */
	@Override
	public Pair<Genotype> crossover(Genotype encoding1, Genotype encoding2) {
		return new Pair<Genotype>(encoding1, encoding2);
	}
}
